<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Annotation Manager</TITLE>
<link href="suif1_80.html" rel=Next>
<link href="suif1_78.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_78.html">previous</A>, <A HREF="suif1_80.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC79" HREF="suif1_toc.html#TOC79">Annotation Manager</A></H2>
<P>
<A NAME="IDX582"></A>
<A NAME="IDX583"></A>

</P>
<P>
The annotation manager keeps track of the annotations that have been
registered.  For each annotation name, it records whether the annotation
is flat or structured and whether it should be written to the output
file.  Additional information is stored for structured annotations.

</P>
<P>
<A NAME="IDX584"></A>
<A NAME="IDX585"></A>
The annotation manager is implemented in the files <TT>`aman.h'</TT> and
<TT>`aman.cc'</TT>.  The <CODE>annote_def</CODE> class is used to hold the
annotation information.  Each <CODE>annote_def</CODE> object records the
information for annotations with a particular name (which can be
accessed with the <CODE>name</CODE> method).  As with the annotations
themselves, the name in the <CODE>annote_def</CODE> is entered in the
<CODE>lexicon</CODE> (see section <A HREF="suif1_102.html#SEC102">Lexicon</A>), except that in this case the
<CODE>annote_def</CODE> constructor automatically makes sure that the name is
in the <CODE>lexicon</CODE>.

</P>
<P>
<A NAME="IDX586"></A>
<A NAME="IDX587"></A>
The manager is implemented as a list of <CODE>annote_def</CODE> objects.  This
list is initialized by the <CODE>init_aman</CODE> function, which is
automatically called when the library is initialized.  The
<CODE>register_annote</CODE> function adds an <CODE>annote_def</CODE> to the list.
An error occurs if the name in the <CODE>annote_def</CODE> is already used in
another registered <CODE>annote_def</CODE>.  Rather than calling the
<CODE>register_annote</CODE> function directly, use the <CODE>ANNOTE</CODE> and
<CODE>STRUCT_ANNOTE</CODE> macros described below to enter new annotations.

</P>
<P>
<A NAME="IDX588"></A>
The information in the manager can be retrieved using the
<CODE>lookup_annote</CODE> function.  Given an annotation name that is entered
in the <CODE>lexicon</CODE>, <CODE>lookup_annote</CODE> searches the list of
registered annotations and returns the <CODE>annote_def</CODE> corresponding
to that name.  If the name is not found, it returns <CODE>NULL</CODE>.

</P>

<UL>
<LI><A HREF="suif1_80.html#SEC80">Flat Annote Defs</A>: Definitions of flat annotations.
<LI><A HREF="suif1_81.html#SEC81">Struct Annote Defs</A>: Definitions of structured annotations.
<LI><A HREF="suif1_82.html#SEC82">Input Annotes</A>: Handling unknown annotations in the input.
</UL>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_78.html">previous</A>, <A HREF="suif1_80.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
